- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions

# MFnDagNode Class Reference

# OpenMaya - API module for common classes | FunctionSet classes

Search for all occurrences

## Detailed Description

DAG Node Function Set.

Provides methods for attaching Function Sets to, querying, and adding children to DAG Nodes. Particularly useful when used in conjunction with the DAG Iterator class (MItDag).

The MFnDagNode function set is used to query and set the attributes of nodes in the DAG (Directed Acyclic Graph). The DAG is a graph that describes the hierarchy of the objects in the model. At each level of the hierarchy there is a four by four transformation matrix that affects all of the objects beneath it in the DAG.

In the DAG, geometry objects (also known as shapes) do not have transformation information associated with them. Only transform nodes have actual transform matrices (see MFnTransform).

Each node that exists in the DAG is also a dependency node that exists in the dependency graph. This makes it possible to control the attributes of a DAG node based on calculations performed by dependency nodes.

There are two ways to specify a DAG node in Maya. The first is to use an MObject handle, which acts as a pointer to a specific node in the DAG. Given only an MObject, it is not possible to do world space operations on a DAG node because there may be more than one path through the DAG to any given node. In other words, it is not possible to identify a particular instance only given an MObject.

In many cases it is preferable to use a DAG path (MDagPath) to specify a DAG node. A DAG path always refers to a specific instance of an object. This makes it possible to perform unambiguous world space transformations.

It is also possible to iterate over the nodes in the DAG using a DAG iterator (MItDag).

Examples:

  cgfxShaderCmd.cpp, closestPointCmd.cpp, closestPointOnNurbsSurfaceCmd.cpp, customAttrManip.cpp, D3DResourceManager.cpp, D3DViewportRenderer.cpp, dagMessageCmd.cpp, footPrintManip.cpp, hairCollisionSolver.cpp, intersectCmd.cpp, intersectOnNurbsSurfaceCmd.cpp, lineManipContainer.cpp, maTranslator.cpp, moveManip.cpp, nodeCreatedCBCmd.cpp, NodeMonitor.cpp, objExport.cpp, OpenGLViewportRenderer.cpp, polyExporter.cpp, polyExporter.h, polyModifierCmd.cpp, polyPrimitiveCmd.cpp, scanDagCmd.cpp, scanDagSyntax.cpp, slopeShaderBehavior.cpp, spiralAnimCurveCmd.cpp, surfaceBumpManip.cpp, and swissArmyManip.cpp.

`#include <MFnDagNode.h>`

Inheritance diagram for MFnDagNode:
[legend]

List of all members.

## Public Types
enum | { kNextPos = 0xff }
| Anonymous enum to store constant values. More...
## Public Member Functions
virtual MFn::Type | type () const
| Function set type.
virtual | ~MFnDagNode ()
| Destructor.
| MFnDagNode ()
| Class Constructor.
| MFnDagNode (MObject &object, MStatus *ret=NULL)
| This method is not available in Python.
| MFnDagNode (const MDagPath &object, MStatus *ret=NULL)
| Class Constructor.
MObject | create (const MTypeId &typeId, MObject &parent=MObject::kNullObj, MStatus *ReturnStatus=NULL)
| Creates a new DAG node with the given type tag.
MObject | create (const MTypeId &typeId, const MString &name, MObject &parent=MObject::kNullObj, MStatus *ReturnStatus=NULL)
| Creates a new DAG node with the given type tag.
MObject | create (const MString &type, MObject &parent=MObject::kNullObj, MStatus *ReturnStatus=NULL)
| Creates a new DAG node with the given type tag.
MObject | create (const MString &type, const MString &name, MObject &parent=MObject::kNullObj, MStatus *ReturnStatus=NULL)
| Creates a new DAG node with the given type tag.
unsigned int | parentCount (MStatus *ReturnStatus=NULL) const
| Determines the number of parent Nodes of the Node.
MObject | parent (unsigned int i, MStatus *ReturnStatus=NULL) const
| Queries the DAG Node attached to the Function Set for the parent Node corresponding to the given index.
MStatus | addChild (MObject &child, unsigned int index=kNextPos, bool keepExistingParents=false)
| Makes the given DAG Node a child of the DAG Node to which this instance of the Function Set is attached.
MStatus | removeChild (MObject &child)
| Removes the given DAG Node from the parent.
MStatus | removeChildAt (unsigned int index)
| Removes the child at the given index from the parent.
unsigned int | childCount (MStatus *ReturnStatus=NULL) const
| Determines the number of child Nodes of the Node.
MObject | child (unsigned int i, MStatus *ReturnStatus=NULL) const
| Queries the DAG Node attached to the Function Set for the child Node corresponding to the given index.
MObject | dagRoot (MStatus *ReturnStatus=NULL)
| Determines the root of the first DAG Path to the DAG Node attached to the Function Set.
bool | hasParent (const MObject &node, MStatus *ReturnStatus=NULL) const
| Determines whether or not the given Node is a parent of the DAG Node attached to the Function Set.
bool | hasChild (const MObject &node, MStatus *ReturnStatus=NULL) const
| Determines whether or not the given Node is a child of the DAG Node attached to the Function Set.
bool | isChildOf (const MObject &node, MStatus *ReturnStatus=NULL) const
| Determines whether or not the DAG Node attached to the Function Set is a child of the given node.
bool | isParentOf (const MObject &node, MStatus *ReturnStatus=NULL) const
| Determines whether or not the DAG Node attached to the Function Set is a parent of the given node.
bool | inUnderWorld (MStatus *ReturnStatus=NULL) const
| Determines whether or not the DAG Node is an underworld node.
bool | inModel (MStatus *ReturnStatus=NULL) const
| Determines whether or not the DAG Node is in the model.
bool | isInstanceable (MStatus *ReturnStatus=NULL) const
| Returns true if the DAG node can be instanced, and false otherwise.
MStatus | setInstanceable (const bool how)
| Sets whether or not the DAG node is instanceable.
bool | isInstanced (bool indirect=true, MStatus *ReturnStatus=NULL) const
| Determines whether the DAG Node attached to the Function Set is directly or indirectly instanced.
bool | isInstancedAttribute (const MObject &attr, MStatus *ReturnStatus=NULL) const
| Returns true if the specified attribute is instanced.
unsigned int | instanceCount (bool total, MStatus *ReturnStatus=NULL) const
| Determines the number of times the Node attached to the Function Set is instanced.
MObject | duplicate (bool instance=false, bool instanceLeaf=false, MStatus *ReturnStatus=NULL) const
| This method duplicates the DAG hierarchy rooted at the current node.
MStatus | getPath (MDagPath &path) const
| Returns a DAG Path to the DAG Node attached to the Function Set.
MStatus | getAllPaths (MDagPathArray &paths) const
| Determines all DAG Paths to the DAG Node attached to the Function Set.
MString | fullPathName (MStatus *ReturnStatus=NULL) const
| Return a string representing the full path from the root of the dag to this object.
MString | partialPathName (MStatus *ReturnStatus=NULL) const
| Return a string representing the partial path from the root of the dag to this object.
MMatrix | transformationMatrix (MStatus *ReturnStatus=NULL) const
| Returns the object space transformation matrix for this DAG node.
bool | isIntermediateObject (MStatus *ReturnStatus=NULL) const
| Returns true if this object is an intermediate in a geometry calculation.
MStatus | setIntermediateObject (bool isIntermediate)
| Sets whether this object is an intermediate in a geometry calculation.
int | objectColor (MStatus *ReturnStatus=NULL) const
| Determines the index for the current user defined inactive color used by the node.
MStatus | setObjectColor (int color)
| Sets the index for the current user defined inactive color used by the node.
bool | usingObjectColor (MStatus *ReturnStatus=NULL) const
| Determines whether or not the user defined inactive color will be used for the node, or whether the default inactive color will be used.
MStatus | setUseObjectColor (bool useObjectColor)
| Sets whether or not the user defined inactive object color will be used.
MColor | hiliteColor (MStatus *ReturnStatus=NULL) const
| Determines the current hilite color used by the node.
bool | usingHiliteColor (MStatus *ReturnStatus=NULL) const
| Determines whether or not the hilite color will be used for the node.
MColor | dormantColor (MStatus *ReturnStatus=NULL) const
| Determines the dormant color used by this node.
MColor | activeColor (MStatus *ReturnStatus=NULL) const
| Determines the active color used by this node.
bool | drawOverrideEnabled (MStatus *ReturnStatus=NULL) const
| Determines whether or not draw override is turned on for this node.
bool | drawOverrideIsReference (MStatus *ReturnStatus=NULL) const
| Determines whether or not Display Type of the draw override is Reference for this node.
bool | drawOverrideIsTemplate (MStatus *ReturnStatus=NULL) const
| Determines whether or not Display Type of the draw override is Template for this node.
bool | drawOverrideColor (MColor &color, MStatus *ReturnStatus=NULL) const
| Determines the draw override color used by this node.
MBoundingBox | boundingBox (MStatus *ReturnStatus=NULL) const
| Returns the bounding box for the dag node in object space.
MDagPath | dagPath (MStatus *ReturnStatus=NULL) const
| Returns the DagPath to which the Function Set is attached.
virtual MStatus | setObject (const MDagPath &path)
| Attaches Function Set to the DAG Node that has the given DAG Path.
virtual MStatus | setObject (MObject &object)
| This method is not available in Python.
MObject | model (MStatus *ReturnStatus=NULL) const
| This method is obsolete.
| MFnDagNode (const MObject &object, MStatus *ret=NULL)
| No script support.
virtual MStatus | setObject (const MObject &object)
| No script support.
## Protected Member Functions
virtual const char * | className () const
| Class name.

## Member Enumeration Documentation

anonymous enum

Search for all occurrences

Anonymous enum to store constant values.

Enumerator:

  kNextPos | used by addChild to indicate the next empty position in the list. Search for all occurrences

## Constructor & Destructor Documentation

~MFnDagNode | ( |  | ) | `[virtual]`

Destructor.

Class Destructor.

Deletes the working copy of the DAG Path to the attached object, if the copy exists.

MFnDagNode | ( |  | ) |

Class Constructor.

Creates a DAG Node Function Set without an attached DAG Node.

MFnDagNode | ( | MObject & | object,
|  | MStatus * | ret = `NULL`
| ) |  |

This method is not available in Python.

Class Constructor

Creates a DAG Node Function Set and attaches it to the given DAG Node.

Parameters:

  [in] | object | The DAG Node to be attached.
  [out] | ret | Status Code (see below)

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for object - not a DAG Node, Node does not exist or no valid pointer to Node

MFnDagNode | ( | const MDagPath & | object,
|  | MStatus * | ret = `NULL`
| ) |  |

Class Constructor.

Creates a DAG Node Function Set and attaches it to the DAG Node that has the given DAG Path.

Parameters:

  [in] | object | The DAG Path of the Node to be attached.
  [out] | ret | Status Code (see below)

Status Codes:
  - MS::kSuccess Success
  - MS::kInsufficientMemory Insufficient memory to make working copy of DAG Path
  - MS::kInvalidParameter Invalid parameter passed for object - invalid Path

MFnDagNode | ( | const MObject & | object,
|  | MStatus * | ret = `NULL`
| ) |  |

No script support.

Class Constructor.

Creates a DAG Node Function Set and attaches it to the given read only DAG Node.

Parameters:

  [in] | object | The read only DAG Node to be attached.
  [out] | ret | Status Code (see below)

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for object - not a DAG Node, Node does not exist or no valid pointer to Node

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Function set type.

Return the class type : MFn::kDagNode.

Reimplemented from MFnDependencyNode.

Reimplemented in MFnAirField, MFnAmbientLight, MFnAreaLight, MFnCamera, MFnCircleSweepManip, MFnCurveSegmentManip, MFnDirectionalLight, MFnDirectionManip, MFnDiscManip, MFnDistanceManip, MFnDragField, MFnField, MFnFluid, MFnFreePointTriadManip, MFnGravityField, MFnHikEffector, MFnIkEffector, MFnIkHandle, MFnIkJoint, MFnInstancer, MFnLattice, MFnLight, MFnManip3D, MFnMesh, MFnNewtonField, MFnNonAmbientLight, MFnNonExtendedLight, MFnNurbsCurve, MFnNurbsSurface, MFnParticleSystem, MFnPfxGeometry, MFnPointLight, MFnPointOnCurveManip, MFnPointOnSurfaceManip, MFnRadialField, MFnRotateManip, MFnScaleManip, MFnSpotLight, MFnStateManip, MFnSubd, MFnToggleManip, MFnTransform, MFnTurbulenceField, MFnUniformField, MFnVolumeAxisField, MFnVolumeLight, and MFnVortexField.

const char * className | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Class name.

Return the class name : "MFnDagNode".

Reimplemented from MFnDependencyNode.

Reimplemented in MFnAirField, MFnAmbientLight, MFnAreaLight, MFnCamera, MFnCircleSweepManip, MFnCurveSegmentManip, MFnDirectionalLight, MFnDirectionManip, MFnDiscManip, MFnDistanceManip, MFnDragField, MFnField, MFnFluid, MFnFreePointTriadManip, MFnGravityField, MFnHikEffector, MFnIkEffector, MFnIkHandle, MFnIkJoint, MFnInstancer, MFnLattice, MFnLight, MFnManip3D, MFnMesh, MFnNewtonField, MFnNonAmbientLight, MFnNonExtendedLight, MFnNurbsCurve, MFnNurbsSurface, MFnParticleSystem, MFnPfxGeometry, MFnPointLight, MFnPointOnCurveManip, MFnPointOnSurfaceManip, MFnRadialField, MFnRotateManip, MFnScaleManip, MFnSpotLight, MFnStateManip, MFnSubd, MFnToggleManip, MFnTransform, MFnTurbulenceField, MFnUniformField, MFnVolumeAxisField, MFnVolumeLight, and MFnVortexField.

MObject create | ( | const MTypeId & | typeId,
|  | MObject & | parent = `MObject::kNullObj`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a new DAG node with the given type tag.

The new node is placed into the DAG.

If a parent is specified, the new node is parented to it, and the new node is returned. If no parent is specified and the new node is a transform, the new node is returned. Otherwise, a transform created and the new node is automatically parented to it. The returned object is the transform, not the new node.

Parameters:

  [in] | typeId | type id of the node to be created
  [in] | parent | the parent of the node to be created
  [out] | ReturnStatus | Status code.

Returns:
  A pointer to the new dependency node object or the transform added above it.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kInvalidParameter parent or typeId is not a DAG node
  - MS::kLicenseFailure application not licensed for attempted operation
  - MS::kInsufficientMemory out of memory
  - MS::kFailure node type is not recognised

MObject create | ( | const MTypeId & | typeId,
|  | const MString & | name,
|  | MObject & | parent = `MObject::kNullObj`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a new DAG node with the given type tag.

The new node is placed into the DAG.

If a parent is specified, the new node is parented to it, and the new node is returned. If no parent is specified and the new node is a transform, the new node is returned. Otherwise, a transform created and the new node is automatically parented to it. The returned object is the transform, not the new node.

Parameters:

  [in] | typeId | type id of the node to be created
  [in] | name | the name to be assigned to the new node If the node's name is not unique, it will be given a unique name by changing its numerical suffix. For example, if this node is called "myNode" and a node by the same name exists, this node will be renamed to "myNode1".
  [in] | parent | the parent of the node to be created
  [out] | ReturnStatus | Status code.

Returns:
  A pointer to the new dependency node object or the transform added above it.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kInvalidParameter parent or typeId is not a DAG node
  - MS::kLicenseFailure application not licensed for attempted operation
  - MS::kInsufficientMemory out of memory
  - MS::kFailure node type is not recognised

MObject create | ( | const MString & | type,
|  | MObject & | parent = `MObject::kNullObj`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a new DAG node with the given type tag.

The new node is placed into the DAG.

If a parent is specified, the new node is parented to it, and the new node is returned. If no parent is specified and the new node is a transform, the new node is returned. Otherwise, a transform created and the new node is automatically parented to it. The returned object is the transform, not the new node.

Parameters:

  [in] | type | Name of the type of DAG node to create.
  [in] | parent | The DAG parent of this node.
  [out] | ReturnStatus | Status code.

Returns:
  The new dependency node or the transform added above it.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kInvalidParameter parent or type is not a DAG node
  - MS::kInsufficientMemory out of memory
  - MS::kLicenseFailure application not licensed for attempted operation
  - MS::kFailure node type is not recognised

MObject create | ( | const MString & | type,
|  | const MString & | name,
|  | MObject & | parent = `MObject::kNullObj`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a new DAG node with the given type tag.

The new node is placed into the DAG.

If a parent is specified, the new node is parented to it, and the new node is returned. If no parent is specified and the new node is a transform, the new node is returned. Otherwise, a transform created and the new node is automatically parented to it. The returned object is the transform, not the new node.

Parameters:

  [in] | type | Name of the type of DAG node to create.
  [in] | name | Name to be assigned to the new node. If the node's name is not unique it will be given a unique name by adding a numerical suffix. For example, if name contains "myNode" and a node with that name already exists, the new node will be named "myNode1".
  [in] | parent | The DAG parent of this node.
  [out] | ReturnStatus | Status code.

Returns:
  The new dependency node or the transform added above it.

Status Codes:
  - MS::kSuccess operation successful
  - MS::kInvalidParameter parent or type is not a DAG node
  - MS::kInsufficientMemory out of memory
  - MS::kLicenseFailure application not licensed for attempted operation
  - MS::kFailure node type is not recognised

unsigned int parentCount | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines the number of parent Nodes of the Node.

Used to determine the upper bound for the parent index (max index = parentCount-1).

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  Number of parent Nodes.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

Examples:
  polyModifierCmd.cpp.

MObject parent | ( | unsigned int | i,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Queries the DAG Node attached to the Function Set for the parent Node corresponding to the given index.

Parameters:

  [in] | i | Index to the parent Node
  [out] | ReturnStatus | Status code.

Returns:
  The parent Node for the given index.

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed fori (index) - index out of range
  - MS::kFailure No valid DAG Node attached to Function Set or failure retrieving parent Node.

Examples:
  polyModifierCmd.cpp.

MStatus addChild | ( | MObject & | child,
|  | unsigned int | index = `kNextPos`,
|  | bool | keepExistingParents = `false`
| ) |  |

Search for all occurrences

Makes the given DAG Node a child of the DAG Node to which this instance of the Function Set is attached.

By default, the child will be added to the end of the child list. If an index is specified, and it is less than or equal to the upper bound, Maya will add the child to the specified index and shift the position of subsequent children onto the next position. If the index is greater than the upper bound, the behavior is undefined.

By default, the child is removed from its existing parents as a result of this operation. If the flag keepExistingParents is set to true, the child will keep its existing parents and a new instance connection will be created for the new node. Any instanced attributes downstream from the new child will be updated with new instance numbers.

Parameters:

  [in] | child | The node to be added as child
  [in] | index | The index that the child should be position. Defaulted to MFnDagNode::kNextPos
  [in] | keepExistingParents | Should the child be instanced?

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed as child - not a DAG Node, Node does not exist or no valid pointer to Node
  - MS::kInsufficientMemory Insufficient memory to add child to model
  - MS::kFailure No valid DAG Node attached to Function Set

MStatus removeChild | ( | MObject & | child | ) |

Search for all occurrences

Removes the given DAG Node from the parent.

Once the child is removed, all children at higher indices would shift 1 position to the left.

If the child being removed is an instance, any instance attributes downstream from the node being removed will be updated with the new instance count.

Parameters:

  [in] | child | The Node to be removed as child

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed as child - not a DAG Node, Node does not exist or no valid pointer to Node
  - MS::kFailure No valid DAG Node attached to Function Set

MStatus removeChildAt | ( | unsigned int | index | ) |

Search for all occurrences

Removes the child at the given index from the parent.

Once the child is removed, all children at higher indices would shift 1 position to the left.

If the child being removed is an instance, any instance attributes downstream from the node being removed will be updated with the new instance count.

Parameters:

  [in] | index | The index of the child.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

unsigned int childCount | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines the number of child Nodes of the Node.

Used to determine the upper bound for the child index (max index = childCount-1).

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  Number of child Nodes.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached

Examples:
  polyModifierCmd.cpp, and surfaceBumpManip.cpp.

MObject child | ( | unsigned int | i,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Queries the DAG Node attached to the Function Set for the child Node corresponding to the given index.

Parameters:

  [in] | i | Index to the child Node
  [out] | ReturnStatus | Status code.

Returns:
  The child Node for the given index.

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed fori (index) - index out of range
  - MS::kFailure No valid DAG Node attached to Function Set or failure retrieving child node.

Examples:
  closestPointCmd.cpp, intersectCmd.cpp, polyModifierCmd.cpp, and surfaceBumpManip.cpp.

MObject dagRoot | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Determines the root of the first DAG Path to the DAG Node attached to the Function Set.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  The DAG root

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

bool hasParent | ( | const MObject & | node,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines whether or not the given Node is a parent of the DAG Node attached to the Function Set.

Parameters:

  [in] | node | Potential parent node
  [out] | ReturnStatus | Status code.

Returns:
  true if the node is a parent, false otherwise.

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for node - not a DAG Node, Node does not exist or no valid pointer to Node
  - MS::kInsufficientMemory Insufficient memory to create working copy of potential parent Node
  - MS::kFailure No valid DAG Node attached to Function Set

bool hasChild | ( | const MObject & | node,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines whether or not the given Node is a child of the DAG Node attached to the Function Set.

Parameters:

  [in] | node | node to check
  [out] | ReturnStatus | Status code.

Returns:
  true if the node is a child, false otherwise.

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for node - not a DAG Node, Node does not exist or no valid pointer to Node
  - MS::kInsufficientMemory Insufficient memory
  - MS::kFailure No valid DAG Node attached to Function Set

bool isChildOf | ( | const MObject & | node,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines whether or not the DAG Node attached to the Function Set is a child of the given node.

Parameters:

  [in] | node | node to check
  [out] | ReturnStatus | Status code.

Returns:
  true is a child, false otherwise.

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for node - not a DAG Node, Node does not exist or no valid pointer to Node
  - MS::kInsufficientMemory Insufficient memory
  - MS::kFailure No valid DAG Node attached to Function Set

bool isParentOf | ( | const MObject & | node,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines whether or not the DAG Node attached to the Function Set is a parent of the given node.

Parameters:

  [in] | node | node to check
  [out] | ReturnStatus | Status code.

Returns:
  true is a parent, false otherwise.

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for node - not a DAG Node, Node does not exist or no valid pointer to Node
  - MS::kInsufficientMemory Insufficient memory
  - MS::kFailure No valid DAG Node attached to Function Set

bool inUnderWorld | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines whether or not the DAG Node is an underworld node.

(An example of an underworld node is a curve on surface.)

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  true if the node is an underworld node, false otherwise.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

bool inModel | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines whether or not the DAG Node is in the model.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  true if the node in the model, false otherwise.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

bool isInstanceable | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns true if the DAG node can be instanced, and false otherwise.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  true if the DAG node is instanceable, false otherwise.

Status Codes:
  - MS::kSuccess successfully queried the DAG node
  - MS::kFailure function set does not have a valid DAG node

MStatus setInstanceable | ( | const bool | how | ) |

Search for all occurrences

Sets whether or not the DAG node is instanceable.

If the node is marked as noninstanceable, then if Maya attempts to create instances on the node the instancing operation will not succeed and instead an error will be reported. A node cannot be marked non-instanceable if it or any of its children are currently instanced. MS::kFailure will be returned it this occurs. The default instanceable state for newly created nodes if true, meaning that nodes can be instanced by default.

Parameters:

  [in] | how | true if the node should be made instanceable, false to make the node noninstanceable.

Returns:
  Status code

Status Codes:
  - MS::kSuccess successfully set the instanceable state on the node
  - MS::kFailure function set does not have a valid node, or the node or one of its child nodes is already instanced and you are attempting to flag the node as non-instanceable, or the node is locked.

bool isInstanced | ( | bool | indirect = `true`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines whether the DAG Node attached to the Function Set is directly or indirectly instanced.

If indirect instance flag is false, the result is true if and only if the Node itself is multiply instanced (node->parentCount > 1).

If the indirect flag is true, the result is true if and only if the Node itself is multiply instanced (node->parentCount > 1) or if the Node is not multiply instanced, but it has a directly instanced parent (node->parentCount()=1 amd parent->parentCount >1).

Parameters:

  [in] | indirect | Indirect instance flag
  [out] | ReturnStatus | Status code.

Returns:
  true if the node is instanced (directly or indirectly according to indirect instance flag), false otherwise.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

bool isInstancedAttribute | ( | const MObject & | attribute,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Returns true if the specified attribute is instanced.

An instanced attribute is an array attribute whose index depends upon which instance of the node is being referred to.

Attributes are not instanced by default.

Parameters:

  [in] | attribute | The attribute to test.
  [out] | ReturnStatus | Status code.

Returns:
  A boolean value indicating whether the attribute is instanced

Status Codes:
  - MS::kSuccess operation successful
  - MS::kInvalidParameter no such attribute on this node
  - MS::kFailure this function set does not have a valid DAG node object

unsigned int instanceCount | ( | bool | total,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines the number of times the Node attached to the Function Set is instanced.

If indirect instance flag is false, the number of direct instances is returned.

If the indirect flag is true, the total number of times the Node is instanced in the DAG above it is returned.

Parameters:

  [in] | total | Indirect instance flag
  [out] | ReturnStatus | Status code.

Returns:
  Number of instances (direct or indirect according to indirect instance flag).

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

MObject duplicate | ( | bool | instance = `false`,
|  | bool | leafInstance = `false`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

This method duplicates the DAG hierarchy rooted at the current node.

The copy will have the same parent, if any, as the original node.

If instance is false then a true copy will be made, otherwise a new node will be created which instances the child nodes of the original node. If instance is false then instanceLeaf is ignored.

If instance is true and instanceLeaf is false then the child nodes of the original node are instanced. If instanceLeaf is true, then the results are similar to a copy, but the leaf level objects are instanced.

If the function set is initialized without an MDagPath, then this method uses the first path to the node. This is only a problem if the node has been instanced, in which case the simple solution is to use an MDagPath to initialize the function set.

Parameters:

  [in] | instance | Duplicate using instancing if true
  [in] | leafInstance | Instance only at the leaf level if true
  [out] | ReturnStatus | Status code.

Returns:
  A reference to the newly created node.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

Examples:
  polyModifierCmd.cpp.

MStatus getPath | ( | MDagPath & | path | ) | const

Search for all occurrences

Returns a DAG Path to the DAG Node attached to the Function Set.

The difference between this method and the method dagPath below is that this one will not fail if the function set is not attached to a dag path, it will always return a path to the node. dagPath will fail if the function set is not attached to a dag path.

Parameters:

  [out] | path | The DAG Path that is found (implicit return)

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

Examples:
  cgfxShaderCmd.cpp, helixTool.cpp, instanceCallbackCmd.cpp, and polyModifierCmd.cpp.

MStatus getAllPaths | ( | MDagPathArray & | paths | ) | const

Search for all occurrences

Determines all DAG Paths to the DAG Node attached to the Function Set.

Parameters:

  [out] | paths | Array of all DAG Paths that are found (implicit return)

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

MString fullPathName | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Return a string representing the full path from the root of the dag to this object.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  The full path name

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

MString partialPathName | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Return a string representing the partial path from the root of the dag to this object.

The partial path is the minimum path that is still unique. This string may contain wildcards.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  The partial path name

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

Examples:
  slopeShaderBehavior.cpp.

MMatrix transformationMatrix | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns the object space transformation matrix for this DAG node.

In general, only transform nodes have matrices associated with them. Nodes such as shapes (geometry nodes) do not have transform matrices.

The identity matrix will be returned if this node does not have a transformation matrix.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  Object space transformation matrix.

Status Codes:
  - MS::kSuccess Success
  - MS::kInsufficientMemory Insufficient memory to create working copy of transformation matrix
  - MS::kFailure No valid DAG Node attached to Function Set

bool isIntermediateObject | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns true if this object is an intermediate in a geometry calculation.

When geometry calculations are performed using dependency nodes, it is sometimes necessary to use intermediate objects. These objects are not draw or rendered. For example, deformers use intermediate geometry during their calculations.

This method exists to provide a more convenient way of accessing the intermediateObject attribute of DAG nodes.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  True if this is an intermediate object.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

Examples:
  polyExporter.cpp.

MStatus setIntermediateObject | ( | bool | isIntermediate | ) |

Search for all occurrences

Sets whether this object is an intermediate in a geometry calculation.

When geometry calculations are performed using dependency nodes, it is sometimes necessary to use intermediate objects. These objects are not draw or rendered. For example, deformers use intermediate geometry during their calculations.

This method exists to provide a more convenient way of accessing the intermediateObject attribute of DAG nodes.

Parameters:

  [in] | isIntermediate | whether to make this an intermediate object

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

Examples:
  polyModifierCmd.cpp.

int objectColor | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines the index for the current user defined inactive color used by the node.

Valid indices are from 0 to 7.

This method is only meaningful for shape or joint nodes (e.g. nurbs curves/surfaces, meshes). It will work for other nodes, but will have no visible effect.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  Index for current user defined inactive color (0 - 7)

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

MStatus setObjectColor | ( | int | index | ) |

Search for all occurrences

Sets the index for the current user defined inactive color used by the node.

This method is only meaningful for shape or joint nodes (e.g. nurbs curves/surfaces, meshes). It will work for other nodes, but will have no visible effect.

Parameters:

  [in] | index | Index for current user color (0 - 7)

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

bool usingObjectColor | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines whether or not the user defined inactive color will be used for the node, or whether the default inactive color will be used.

This method is only meaningful for shape or joint nodes (e.g. nurbs curves/surfaces, meshes). It will work for other nodes, but will have no visible effect.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  True if using the user defined inactive object color

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

MStatus setUseObjectColor | ( | bool | useObjectColor | ) |

Search for all occurrences

Sets whether or not the user defined inactive object color will be used.

This method is only meaningful for shape or joint nodes (e.g. nurbs curves/surfaces, meshes). It will work for other nodes, but will have no visible effect.

Parameters:

  [in] | useObjectColor | True means the user defined inactive object color will be used

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

MColor hiliteColor | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines the current hilite color used by the node.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  The current hilite color.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

bool usingHiliteColor | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines whether or not the hilite color will be used for the node.

hilite command sets this flag to true.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  True if using the hilite color.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

MColor dormantColor | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines the dormant color used by this node.

The order to determine the dormant color is:

- hilite color if hilite color is used
- object color if user defined object color is used
- the dormant color for this kind of dag node

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  The dormant color.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

MColor activeColor | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines the active color used by this node.

The active color is the active color for this kind of dag node.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  The active color.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

bool drawOverrideEnabled | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines whether or not draw override is turned on for this node.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  True if draw override is turned on.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

bool drawOverrideIsReference | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines whether or not Display Type of the draw override is Reference for this node.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  True if Display Type is Reference.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

bool drawOverrideIsTemplate | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determines whether or not Display Type of the draw override is Template for this node.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  True if Display Type is Template.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

bool drawOverrideColor | ( | MColor & | color,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | const

Search for all occurrences

Determines the draw override color used by this node.

Returns true if there is a draw override color. Otherwise, returns false and color parameter is not changed.

Parameters:

  [out] | color | The draw override color.
  [out] | ReturnStatus | Status code.

Returns:
  True if a draw override color is used.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

MBoundingBox boundingBox | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns the bounding box for the dag node in object space.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  The bounding box for the dag node

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set

MDagPath dagPath | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns the DagPath to which the Function Set is attached.

The difference between this method and the method getPath above is that this one will fail if the function set is not attached to a dag path. getPath will find a dag path if the function set is not attached to one.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  An MDagPath that references the object to which the Function Set is attached. If the function set is not attached to a dag path an uninitialized MDagPath will be returned.

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Object Error

MStatus setObject | ( | const MDagPath & | objectPath | ) | `[virtual]`

Search for all occurrences

Attaches Function Set to the DAG Node that has the given DAG Path.

Parameters:

  [in] | objectPath | DAG Path to Node to be attached.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for objectPath - invalid Path or target Node is not a DAG Node, does not exist or has no accessible pointer
  - MS::kInsufficientMemory Insufficient memory to create working copy of DAG Path

Examples:
  cgfxShaderCmd.cpp, closestPointCmd.cpp, closestTangentUAndDistance.cpp, getPointAndNormal.cpp, instanceCallbackCmd.cpp, intersectCmd.cpp, polyModifierCmd.cpp, swissArmyManip.cpp, and testNobjectNode.cpp.

MStatus setObject | ( | MObject & | object | ) | `[virtual]`

Search for all occurrences

This method is not available in Python.

Attaches Function Set to given DAG Node.

Parameters:

  [in] | object | Target Node for attachment.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for node - not a DAG Node, Node does not exist or no valid pointer to Node

Reimplemented from MFnBase.

MObject model | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

This method is obsolete.

Deprecated:
  The model returned is an unknown type to the API and now the method always returns MObject::kNullObj.

Parameters:

  [out] | ReturnStatus | Status code.

Returns:
  The model in which the DAG Node resides.

Status Codes:
  - MS::kSuccess Success
  - MS::kFailure No valid DAG Node attached to Function Set or failure retrieving model.

MStatus setObject | ( | const MObject & | object | ) | `[virtual]`

Search for all occurrences

No script support.

Attaches Function Set to given read only DAG Node.

Parameters:

  [in] | object | Target Node for attachment.

Returns:
  Status Code

Status Codes:
  - MS::kSuccess Success
  - MS::kInvalidParameter Invalid parameter passed for node - not a DAG Node, Node does not exist or no valid pointer to Node

Reimplemented from MFnBase.

MFnDagNode MFnDagNode MFnDagNode MFnDagNode MFnDagNode MFnDagNode MFnDagNode MFnDagNode MFnDagNode MFnDagNode
MFnDagNode MFnDagNode MFnDagNode MFnDagNode MFnDagNode MFnDagNode MFnDagNode MFnDagNode MFnDagNode MFnDagNode